unit define;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  T3DPos = record
    X,Y,Z:Integer;
  end;

type
  T3DVector = record
    X,Y,Z:Integer;
  end;

type
  TSize = record
    XSize,YSize,ZSize:Integer;
  end;

//eor䂷@Ԃ̏ɍvĂ
type
  TFPSChecker = record
    Count:Integer;
    Time:Integer;
    FrameTime:Integer;
    FrameTimeAni:Integer;
    OneFrameTime:Integer;
    FPS:integer;
    kFrameTime:Integer;
end;

TBitmapList = class
  private
    BMPNames:TStrings;
  public
    function getBitmap(key:String):TBitmap; virtual;
    property Items[key:String]:TBitmap read getBitmap; default;
    constructor Create;
    destructor Destroy;override;
end;

function  M3DPos(X1,Y1,Z1:Integer):T3DPos;
function  MSize(X,Y,Z:Integer):TSize;
function  OverlapRect(Rect1,Rect2:TRect):Boolean;
function  Max(B1, B2: Integer): Integer;
function  Min(B1, B2: Integer): Integer;
function  Distance(Pos1,Pos2:T3DPos):Integer;
procedure ReadBMPHeader(name:String; var bi:TBitmapInfoHeader);
function  RectInRect(Rec1,Rec2:TRect):Boolean;

implementation

function TBitmapList.getBitmap(key:String):TBitmap;
var
  i,idx:Integer;
  bih:TBITMAPINFOHEADER;
  Bitmap:TBitmap;
  fname:String;
begin

  //L[gČ
  idx:=-1;
  for i:=0 to BMPNames.Count-1 do begin
    if BMPNames[i] = key then begin
      idx:=i;
      break;
    end;
  end;

  if idx=-1 then begin
    //V
    fname:=key;

    ReadBMPHeader(fname,bih);

    Bitmap:=TBitmap.Create;

    Bitmap.LoadFromFile(fname);

    BMPNames.AddObject(key,Bitmap);
    result:=Bitmap;

  end else begin
    result:=Pointer(BMPNames.Objects[idx]);
  end;
end;

constructor TBitmapList.Create;
begin
  BMPNames:=TStringList.Create;
end;

destructor TBitmapList.Destroy;
begin
  BMPNames.Free;
end;
function  RectInRect(Rec1,Rec2:TRect):Boolean;
begin

  result:=False;

  if (Rec1.Left   <= Rec2.Left  ) And
     (Rec1.Top    <= Rec2.Top   ) And
     (Rec1.Right  >= Rec2.Right ) And
     (Rec1.Bottom >= Rec2.Bottom) then result:=True;

end;

procedure ReadBMPHeader(name:String; var bi:TBitmapInfoHeader);
var
  f:File;
begin
  AssignFile(f,name);
  Reset(f,1);
  Seek(f,sizeof(TBitmapFileHeader));
  BlockRead(f,bi,sizeof(TBitmapInfoHeader));
  CloseFile(f);
end;

function Distance(Pos1,Pos2:T3DPos):Integer;
var x,y,z:Integer;
begin

  x:=Pos1.X-Pos2.X;
  y:=Pos1.Y-Pos2.Y;
  z:=Pos1.Z-Pos2.Z;

  Result:=Trunc(Sqrt(x*x+y*y+z*z));

end;

function M3DPos(X1,Y1,Z1:Integer):T3DPos;
begin

  with result do begin

    X:=X1;
    Y:=Y1;
    Z:=Z1;

  end;

end;

function MSize(X,Y,Z:Integer):TSize;
begin

  with result do begin

    XSize:=X;
    YSize:=Y;
    ZSize:=Z;

  end;

end;

function OverlapRect(Rect1,Rect2:TRect):Boolean;
begin

  result:= (Rect1.Left   < Rect2.Right )And
           (Rect1.Right  > Rect2.Left  )And
           (Rect1.Top    < Rect2.Bottom)And
           (Rect1.Bottom > Rect2.Top   );

end;

function Max(B1, B2: Integer): Integer;
begin
  if B1>=B2 then Result := B1 else Result := B2;
end;

function Min(B1, B2: Integer): Integer;
begin
  if B1<=B2 then Result := B1 else Result := B2;
end;

end.
