unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, MMSYSTEM, Menus, define, ExtCtrls, FMXUtils, Buttons, ComCtrls;

type
  TGameData = record
    Tanni:Integer;
    Time:Integer;
    Count:Integer;
    Name:String[8];
    Score:Integer;
end;

type
  TWnd = class(TForm)
    gButton: TButton;
    bReset: TButton;
    bSave: TButton;
    bChange: TButton;
    Menu: TMainMenu;
    F1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    fontImage: TImageList;
    Popup: TPopupMenu;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    SD: TSaveDialog;
    L1: TMenuItem;
    OD: TOpenDialog;
    N14: TMenuItem;
    O1: TMenuItem;
    N15: TMenuItem;
    asReset: TSpeedButton;
    bLoad: TButton;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N110: TMenuItem;
    N21: TMenuItem;
    N1001: TMenuItem;
    N1011: TMenuItem;
    N1002: TMenuItem;
    N101: TMenuItem;
    Status: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bChangeClick(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure N5Click(Sender: TObject);
    procedure bResetClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
    procedure N7Click(Sender: TObject);
    procedure L1Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure asResetClick(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure bLoadClick(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N1002Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure N1001Click(Sender: TObject);
    procedure N1011Click(Sender: TObject);
    procedure N110Click(Sender: TObject);
    procedure gButtonMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private 錾 }
  public
    { Public 錾 }
    BitmapList:TBitmapList;
    procedure IdleEvent(Sender:TObject;var Done:Boolean);
    procedure DrawTime(Str:STring;P:TPoint);
    procedure CheckTime;
    procedure UpDatePanel;
//    procedure
  end;

var
  Wnd: TWnd;
  startTime:Integer;
  stopTime:Integer;
  BackBuffer:TBitmap;
  strTime,cntTime:String;
  bi:TBITMAPINFO;
  G_PATH,S_PATH:String;
  Tanni:Integer;
  GameData:TGameData;
  AutoReset:Boolean;
  MissCount:Integer;

implementation

uses about,input,info;

{$R *.DFM}

procedure TWnd.DrawTime(Str:String;P:TPoint);
var i:Integer;
    len,n:Integer;
    Bitmap:TBitmap;
begin

  len:=StrLen(PChar(Str));

  Bitmap:=TBitmap.Create;
  Bitmap.Width :=11;
  Bitmap.Height:=11;

  for i:= 1 to len do begin
      n:=DWORD(Str[i])-48;
      if n >= 0 then begin
      fontImage.GetBitmap(n,Bitmap);
      BackBuffer.Canvas.Draw((i-1)*7+P.X,P.Y,Bitmap);
      end;
  end;
 Bitmap.Free;

end;

procedure TWnd.IdleEvent(Sender:TObject;var Done:Boolean);
begin

  if (not InPutBox.Visible) AND (GameData.Name = '') then begin
     Enabled:=False;
     InputBox.Show;
  end;

  if gButton.Caption = '͂߁I' then begin

     BackBuffer.Canvas.Draw(0,0,BitmapList.getBitmap(G_PATH+'back.bmp'));
     strTime:=Format('%12d',[stopTime div Tanni]);
     cntTime:=Format('%6d',[GameData.Count]);
     DrawTime(strTime,Point(16,20));
     DrawTime(cntTime,Point(78,72));
     Wnd.Canvas.Draw(64,4,BackBuffer);

     GameData.Tanni:=Tanni;
     GameData.Time:=stopTime;

     bChange.Enabled:=True;
     bReset.Enabled :=True;
     bSave.Enabled  :=True;
     asReset.Enabled:=True;
     bLoad.Enabled  :=True;

  end else begin

  ////////////////////////////////////////////

     BackBuffer.Canvas.Draw(0,0,BitmapList.getBitmap(G_PATH+'back.bmp'));
     strTime:=Format('%12d',[(GetTickCount-startTime+stopTime) div Tanni]);
     cntTime:=Format('%6d',[GameData.Count]);
     DrawTime(strTime,Point(16,20));
     DrawTime(cntTime,Point(78,72));
     Wnd.Canvas.CopyRect(Rect(64,4,64+128,100),BackBuffer.Canvas,
     Rect(0,0,128,96));

     bChange.Enabled:=False;
     bReset.Enabled :=False;
     bSave.Enabled  :=False;
     asReset.Enabled:=False;
     bLoad.Enabled  :=False;

  ////////////////////////////////////////////

  end;

  Done:=False;

end;

procedure TWnd.FormCreate(Sender: TObject);
var data:TSearchRec;
begin

  Tanni:=1;
  GameData.Tanni:=Tanni;
  GameData.Time:=0;
  GameData.Count:=0;

  startTime:=0;
  stopTime:=0;

  G_PATH:=ExtractFilePath(Application.Exename)+'\pic\';
  S_PATH:=GetCurrentDir+'\save';

  if FindFirst(S_PATH,faDirectory,data) <> 0 then begin
     if MessageBoxEX(Handle,PChar('f[^t@CۑtH_܂B'
        +#13+'tH_쐬܂H'+#13#13+'쐬𐄏'),
        PChar('ǂH'),MB_YESNO OR MB_ICONQUESTION,LANG_NEUTRAL)
        =IDYES then begin
        CreateDirectory(PChar(S_PATH),nil);
        MessageBoxEX(Handle,PChar('tH_쐬܂B'+#13+
        'Af[^͂̃tH_ɕۑ܂B'),
        PChar('쐬I'),MB_OK OR MB_ICONINFORMATION,
        LANG_NEUTRAL);
     end else begin

     end;
  end;
  FindClose(data);

  OD.InitialDir:=S_PATH;
  SD.InitialDir:=S_PATH;
  S_PATH:=ExtractFilePath(Application.Exename)+'\save\';

  //
  BitmapList:=TBitmapList.Create;

  //obNobt@̐ݒ
  BackBuffer:=TBitmap.Create;
  BackBuffer.Width :=128;
  BackBuffer.Height:=96;
  BackBuffer.Canvas.Font.Color:=$FFFFFF;
  BackBuffer.Canvas.Font.Size:=8;
  BackBuffer.Canvas.Font.Pitch:=fpFixed;
  BackBuffer.Canvas.Brush.Color:=$000000;
  BackBuffer.Canvas.FillRect(BackBuffer.Canvas.ClipRect);

  //AChO[`̓\t
  Application.OnIdle:=IdleEvent;

end;

procedure TWnd.FormDestroy(Sender: TObject);
begin

  BackBuffer.Free;
  BitmapList.Free;

end;

procedure TWnd.bChangeClick(Sender: TObject);
var p:TPoint;
begin

  getCursorPos(P);
  if Sender is TMenuItem then begin
     Popup.Popup(Left+4,P.Y-4);
  end else begin
     Popup.Popup(P.X,P.Y);
  end;

end;

procedure TWnd.N10Click(Sender: TObject);
begin
  N10.Checked:=True;
  N17.Checked:=True;
  Tanni:=1;
end;

procedure TWnd.N11Click(Sender: TObject);
begin
  N11.Checked:=True;
  N18.Checked:=True;
  Tanni:=1000;
end;

procedure TWnd.bSaveClick(Sender: TObject);
var F:File;
begin

  if SD.Execute then begin
     AssignFile(F,SD.FileName);
     Rewrite(F,1);
     BlockWrite(F,GameData,8+256);
     CloseFile(F);
     SD.FileName:='';
  end;

end;

procedure TWnd.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if MessageBoxEX(Handle,PChar('IłH'),PChar('Ō()̈ꌾ'),
     MB_YESNO OR MB_ICONQUESTION,LANG_NEUTRAL)
     = IDYES then begin

     canClose:=True;

  end else canClose:=False;

end;

procedure TWnd.N5Click(Sender: TObject);
begin
  Enabled:=False;
  AboutBox.Show;
end;

procedure TWnd.bResetClick(Sender: TObject);
begin
  stopTime:=0;
end;

procedure TWnd.N2Click(Sender: TObject);
begin
  bChange.OnClick(Sender);
end;

procedure TWnd.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TWnd.N6Click(Sender: TObject);
begin
  ExecuteFile('http://ueno.cool.ne.jp/pokumura/','','',SW_SHOW);
end;

procedure TWnd.N7Click(Sender: TObject);
begin
  ExecuteFile('mailto:delphier@yahoo.co.jp','','',SW_SHOW);
end;

procedure TWnd.UpDatePanel;
var
    i:Integer;
    Com:TComponent;
    MenuItem:TMenuItem;
    StrTanni:String;
begin

  Status.Panels[0].Text:='OF'+GameData.Name;

  for i:= 0 to ComponentCount-1 do begin
      Com:=Components[i];
      if Com is TMenuItem then begin
         MenuItem:=Com as TMenuItem;
         if MenuItem.Parent = N16 then begin
            if MenuItem.Checked then begin
               StrTanni:=MenuItem.Caption;
               break;
            end;
         end;
      end;
  end;

  Status.Panels[1].Text:='PʁF'+StrTanni;
  Status.Panels[2].Text:='Score:'+IntToStr(GameData.Score);

end;

procedure TWnd.L1Click(Sender: TObject);
var F:File;
begin
  if OD.Execute then begin
     AssignFile(F,OD.FileName);
     Reset(F,1);
     BlockRead(F,GameData.Tanni,sizeof(GameData));
     CloseFile(F);
     stopTime:=GameData.Time;
     Tanni:=GameData.Tanni;
     OD.FileName:='';
     CheckTime;
     UpDatePanel;

  end;
end;

procedure TWnd.N15Click(Sender: TObject);
begin
  N15.Checked:= not N15.Checked;
  AutoReset:=N15.Checked;
  asReset.Down:=not asReset.Down;
end;

procedure TWnd.asResetClick(Sender: TObject);
begin
//  asReset.Down:=not asReset.Down;
  AutoReset:= not AutoReset;
  N15.Checked:=not N15.Checked;
end;


procedure TWnd.N17Click(Sender: TObject);
begin
  Popup.Items[0].Items[0].OnClick(Self);
end;

procedure TWnd.N18Click(Sender: TObject);
begin
  Popup.Items[0].Items[1].OnClick(Self);
end;

procedure TWnd.N19Click(Sender: TObject);
begin
  Popup.Items[0].Items[2].OnClick(Self);
end;

procedure TWnd.N20Click(Sender: TObject);
begin
  Popup.Items[0].Items[3].OnClick(Self);
end;

procedure TWnd.bLoadClick(Sender: TObject);
begin
  L1.OnClick(Self);
end;

procedure TWnd.N14Click(Sender: TObject);
begin
  infoBox.Show;
  Enabled:=False;
end;

procedure TWnd.N1002Click(Sender: TObject);
begin
  N1002.Checked:=True;
  N1001.Checked:=True;
  Tanni:=10;
end;

procedure TWnd.N101Click(Sender: TObject);
begin
  N101.Checked:=True;
  N1011.Checked:=True;
  Tanni:=100;

end;

procedure TWnd.N1001Click(Sender: TObject);
begin
  N1002.OnClick(Self);
end;

procedure TWnd.N1011Click(Sender: TObject);
begin
  N101.OnClick(Self);
end;

procedure TWnd.N110Click(Sender: TObject);
begin
  bSave.OnClick(Sender);
end;

procedure TWnd.gButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin

 if Button <> mbLeft then Exit;
 
  if gButton.Caption = '͂߁I' then begin
     startTime:=timeGetTime;
     if AutoReset then
     stopTime:=0;
     gButton.Caption:='Ƃ߂I'
  end else
  if gButton.Caption = 'Ƃ߂I' then begin
     Inc(stopTime,timeGetTime-startTime);
     gButton.Caption:='͂߁I';
     Inc(GameData.Count);
     Inc(GameData.Score,10);
     CheckTime;
     UpDatePanel;
  end;


end;

procedure TWnd.CheckTime;
var i:Integer;
    len:Integer;
    top:char;
    moji:char;
    zcnt:Integer;
    result:Boolean;
    text:String;
    Add:Integer;
begin

  // ]ڂ̔
  ///////////////////////////////////////

//  Add:=0;

  //eϐ̏
  len:=lStrLen(PChar(IntToStr(StopTime div GameData.Tanni)));
  zcnt:=1;
  result:=True;
  Text:=IntToStr(StopTime div GameData.Tanni);

  //p[v
  top:=Text[1];
  for i:= 2 to len do begin

      moji:=Text[i];

      if moji = top then begin
         Inc(zcnt);
         result:=True;
      end else begin
         result:=False;
      end;

  end;

  if (result) AND (zcnt = len) AND (zcnt > 1) then begin

     Add:=5000 div GameData.Tanni *len*10;
     Inc(GameData.Score,Add);

     MessageBoxEX(Handle,PChar(IntToStr(StopTime div Tanni)+' łB'+IntToStr(len)+
     ' ̃]ڂłII'+#13+'_ '+IntToStr(Add)+'AbvII'),
     PChar(']ځII'),MB_OK OR MB_ICONINFORMATION,
     LANG_NEUTRAL);
     MissCount:=0;
     Exit;
  end else
  if (not result) AND (len > 1) AND (zcnt > len div 2) then begin

     MessageBoxEX(Handle,PChar(' '+IntToStr(len)+'̂ '+IntToStr(zcnt)+
     '̂ɁDDD'),PChar('ɂII'),MB_OK OR MB_ICONINFORMATION,
     LANG_NEUTRAL);

  end;

  ///////////////////////////////////////

  //͊KiII
  /////////////////////////////////////////////
  zcnt:=0;
  top:=text[1];
  for i:= 2 to len+1 do begin

      moji:=text[i];
      if DWORD(moji) = DWORD(top)+1 then begin
         Inc(zcnt);
         top:=moji;
      end;

  end;

  if (zcnt = len-1)AND(len > 1) then begin

     Add:=7000 div GameData.Tanni *len*10;
     Inc(GameData.Score,Add);

     MessageBoxEX(Handle,PChar(IntToStr(StopTime div Tanni)+' łB'+IntToStr(len)+' ̊KiłII'+
     #13+'_ '+IntToStr(Add)+'AbvII'),
     PChar('KiIIII'),MB_OK OR MB_ICONINFORMATION,
     LANG_NEUTRAL);
     MissCount:=0;
     Exit;
  end;
  //////////////////////////////////////////////////

  //́A҂܁IIII
  //////////////////////////////////////////////////////////
  zcnt:=0;
  for i:= 2 to len+1 do begin

      moji:=text[i];
      if moji <> '0' then break;
      Inc(zcnt);

  end;

  if (zcnt = len-1)AND(len > 1) then begin

     Add:=3000 div GameData.Tanni *len*10;
     Inc(GameData.Score,Add);
     
     MessageBoxEX(Handle,PChar(IntToStr(StopTime div Tanni)+' łB҂łII'+
     #13+'_ '+IntToStr(Add)+'AbvII'),
     PChar('҂II'),MB_OK OR MB_ICONINFORMATION,
     LANG_NEUTRAL);
     MissCount:=0;
     Exit;
  end;
  //////////////////////////////////////////////////////////


  Inc(MissCount);

  if MissCount = 100 then begin
     Add:=10000;
     Inc(GameData.Score,Add);
     MessageBoxEX(Handle,PChar('߂łƂ܂IIII'+#13+
     'ɂPOOA~XłII'+#13+'_ '+IntToStr(Add)+'AbvII'),
     PChar('bZ[W'),MB_OK OR MB_ICONEXCLAMATION,LANG_NEUTRAL);
     MissCount:=0;
  end else
  if MissCount =  50 then begin
     MessageBoxEX(Handle,PChar('`DDDB'+#13+
     'TOA~XłII'+#13+'ȂłȂɂłȂȂDDB'),
     PChar('bZ[W'),MB_OK OR MB_ICONEXCLAMATION,LANG_NEUTRAL);
  end else
  if MissCount =  20 then begin
     MessageBoxEX(Handle,PChar('قƁAo܂˂DDDB'+#13+
     'QOA~XĂ̂ɁDDDB'+#13+'܂Â܂II'
     ),PChar('bZ[W'),MB_OK OR MB_ICONEXCLAMATION,LANG_NEUTRAL);
  end else
  if MissCount =  10 then begin
     MessageBoxEX(Handle,PChar('ȂȂo܂˂DDDB'+#13+
     'POA~XĂ̂ɁDDDB'),PChar('bZ[W'),MB_OK OR MB_ICONEXCLAMATION,LANG_NEUTRAL);
  end;

end;

end.
